/*
In managed C++, to indicate that a class will be used only as a parent 
for other classes, create it as abstract by using the __abstract  
keyword. The keyword precedes the name of the class.
*/

/*
In C++, a class is referred to as abstract if it serves (only) as a base 
or parent for other classes. That is, you cannot declare a variable of 
that class nor can you use it as you would a regular class. To create an 
abstract class in C++, at least one of its methods must be pure virtual. 
A pure virtual method is one that is not implemented or defined in that 
class. It is created using  = 0; on its right side when declaring it.
*/

#pragma once

public __abstract __gc class Shape
{
public:
	Shape(void);
	virtual ~Shape(void);
protected:
	virtual double Perimeter(void) = 0;
	virtual double Area(void) = 0;
};
