/*
Chaining up
*/
#include <iostream>
using namespace std;

class Vehicle {
public:
    Vehicle() {cout << "Vehicle Constructor" << endl;}
    virtual ~Vehicle() {cout << "Vehicle Destructor" << endl;}

    virtual void accelerate() const {cout << "Vehicle Accelerating" << endl;}

    virtual void setAcceleration(double a) {acceleration = a;}
    virtual double getAcceleration() const {return acceleration;}

protected:
    double acceleration;
};

class Car: public Vehicle {
public:
    Car() {cout << "Car Constructor" << endl;}
    virtual ~Car() {cout << "Car Destructor" << endl;}

    virtual void accelerate() const {cout << "Car Accelerating" << endl;}
    virtual void drive() const {cout << "Car Driving" << endl;}

};

class Jet: public Vehicle {
public:
    Jet() {cout << "Jet Constructor" << endl;}
    virtual ~Jet() {cout << "Jet Destructor" << endl;}

    virtual void fly() const {cout << "Jet flying" << endl;}
};

class JetCar: public Car, public Jet {
public:
    JetCar() {cout << "JetCar Constructor" << endl;}
    virtual ~JetCar() {cout << "JetCar Destructor" << endl;}

    virtual void drive() const {cout << "JetCar driving" << endl;}
    virtual void fly() const {cout << "JetCar flying" << endl;}

    virtual void setAcceleration(double a)
    {
        cout << "Could be doing anything here" << endl;
        Jet::setAcceleration(a);
        cout << "Here, too." << endl;
    }
    virtual double getAcceleration() const
    {
        cout << "Could be doing anything here" << endl;
        return Jet::getAcceleration();
    }
};

int main() {

    JetCar myJetCar;

    myJetCar.setAcceleration(39.2);
    cout << "Accelerating at " << myJetCar.getAcceleration() << endl;

    return 0;
}
